/********************************** (C) COPYRIGHT *******************************
* File Name          : main.c
* Author             : WCH
* Version            : V1.0.0
* Date               : 2019/10/15
* Description        : Main program body.
*******************************************************************************/ 

/*
 *@Note
*/

#include "debug.h"

/* Global typedef */
/* Global define */
/* Global Variable */ 

void LED_Init(void)
{
 GPIO_InitTypeDef  GPIO_InitStructure={0};                //һGPIO_InitTypeDef͵Ľṹ

 RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOA, ENABLE);    //ʹLEDصGPIO˿ʱ

 GPIO_InitStructure.GPIO_Pin = GPIO_Pin_0|GPIO_Pin_1;     //GPIO
 GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP;         //GPIOģʽΪ
 GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;        //GPIOٶ
 GPIO_Init(GPIOA, &GPIO_InitStructure);                   //ÿ⺯ʼGPIOA

 GPIO_SetBits(GPIOA,GPIO_Pin_0|GPIO_Pin_1);               //ߵƽ
}

void PVD_Config(void)
{
  NVIC_InitTypeDef NVIC_InitStructure={0};
  EXTI_InitTypeDef EXTI_InitStructure={0};

  /* Enable PWR and BKP clock */
  RCC_APB1PeriphClockCmd(RCC_APB1Periph_PWR | RCC_APB1Periph_BKP, ENABLE);

  NVIC_PriorityGroupConfig(NVIC_PriorityGroup_1);
  
  /* ʹ PVD ж */
  NVIC_InitStructure.NVIC_IRQChannel = PVD_IRQn;
  NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 0;
  NVIC_InitStructure.NVIC_IRQChannelSubPriority = 0;
  NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;
  NVIC_Init(&NVIC_InitStructure);
      
  /*  EXTI16(PVD ) ½ж*/
  EXTI_ClearITPendingBit(EXTI_Line16);
  EXTI_InitStructure.EXTI_Line = EXTI_Line16;
  EXTI_InitStructure.EXTI_Mode = EXTI_Mode_Interrupt;
  EXTI_InitStructure.EXTI_Trigger = EXTI_Trigger_Rising_Falling;
  EXTI_InitStructure.EXTI_LineCmd = ENABLE;
  EXTI_Init(&EXTI_InitStructure);

  /* PVDѹֵ */
	/*弶ԼʵӦҪ*/
  PWR_PVDLevelConfig(PWR_PVDLevel_2V7);

  /* ʹPVD */
  PWR_PVDCmd(ENABLE);
}
/*******************************************************************************
* Function Name  : main
* Description    : Main program.
* Input          : None
* Return         : None
*******************************************************************************/
int main(void)
{
  Delay_Init();
	USART_Printf_Init(115200);                             /* printf using USART1 */
	LED_Init();
	PVD_Config();
	 
  GPIO_ResetBits(GPIOA,GPIO_Pin_0);

  printf("PWRCSR=%x\r\n",PWR->CSR);
	
	printf("SystemClk:%d\r\n",SystemCoreClock);

 
	while(1)
  {		
		Delay_Ms(500);
		
	}
}

/**
  * @brief  This function handles the PVD Output interrupt request.
  * @param  None
  * @retval None
  */
void PVD_IRQHandler(void)
{
  if(EXTI_GetITStatus(EXTI_Line16) != RESET)
  {
		printf("ENter\r\n");
    /* Clear the Key Button EXTI line pending bit */
    EXTI_ClearITPendingBit(EXTI_Line16);
  }
}

